Index: LMDZ5/trunk/libf/phylmd/cosp/cosp_types.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/cosp_types.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/cosp_types.F90	(revision 2428)
@@ -23,21 +23,12 @@
 ! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-!
-! History:
-! Jul 2007 - A. Bodas-Salcedo - Initial version
-! Feb 2008 - R. Marchand      - Added Quickbeam types and initialisation
-! Oct 2008 - H. Chepfer       - Added PARASOL reflectance diagnostic
-! Nov 2008 - R. Marchand      - Added MISR diagnostics
-! Nov 2008 - V. John          - Added RTTOV diagnostics
-!
-! 
 MODULE MOD_COSP_TYPES
     USE MOD_COSP_CONSTANTS
     USE MOD_COSP_UTILS
 
-    use radar_simulator_types, only: class_param, mie, nd, mt_nd, dmax, dmin, mt_ttl, mt_tti, cnt_liq, cnt_ice	! added by roj Feb 2008
+    use radar_simulator_types, only: class_param, nd, mt_nd, dmax, dmin
 
     IMPLICIT NONE
-    
+
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 !----------------------- DERIVED TYPES ----------------------------    
@@ -46,10 +37,20 @@
   ! Configuration choices (simulators, variables)
   TYPE COSP_CONFIG
-     logical :: Lradar_sim,Llidar_sim,Lisccp_sim,Lmisr_sim,Lrttov_sim,Lstats,Lwrite_output, &
-                Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,Lcfad_dbze94, &
-                Lcfad_lidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp2,Lcllcalipso, &
-                Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lctpisccp,Ldbze94,Ltauisccp,Ltclisccp, &
-                Llongitude,Llatitude,Lparasol_refl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
-                Lfrac_out,Lbeta_mol532,Ltbrttov
+     logical :: Lradar_sim,Llidar_sim,Lisccp_sim,Lmodis_sim,Lmisr_sim,Lrttov_sim,Lstats,Lwrite_output, &
+                Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,LcfadDbze94, &
+                LcfadLidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp,Lcllcalipso, &
+                Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lpctisccp,Ldbze94,Ltauisccp,Lcltisccp, &
+                Ltoffset,LparasolRefl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
+                Lclcalipsoliq,Lclcalipsoice,Lclcalipsoun, &
+                Lclcalipsotmp,Lclcalipsotmpliq,Lclcalipsotmpice,Lclcalipsotmpun, &
+	              Lcltcalipsoliq,Lcltcalipsoice,Lcltcalipsoun, &
+                Lclhcalipsoliq,Lclhcalipsoice,Lclhcalipsoun, &
+                Lclmcalipsoliq,Lclmcalipsoice,Lclmcalipsoun, &
+                Lcllcalipsoliq,Lcllcalipsoice,Lcllcalipsoun, &
+                Lfracout,LlidarBetaMol532,Ltbrttov, &
+                Lcltmodis,Lclwmodis,Lclimodis,Lclhmodis,Lclmmodis,Lcllmodis,Ltautmodis,Ltauwmodis,Ltauimodis,Ltautlogmodis, &
+                Ltauwlogmodis,Ltauilogmodis,Lreffclwmodis,Lreffclimodis,Lpctmodis,Llwpmodis, &
+                Liwpmodis,Lclmodis
+
      character(len=32) :: out_list(N_OUT_LIST)
   END TYPE COSP_CONFIG
@@ -145,5 +146,7 @@
     ! Arrays with dimensions (Npoints,Nlevels)
     real,dimension(:,:),pointer :: beta_mol   ! Molecular backscatter
+    real,dimension(:,:),pointer :: temp_tot
     ! Arrays with dimensions (Npoints,Ncolumns,Nlevels)
+    real,dimension(:,:,:),pointer :: betaperp_tot   ! Total backscattered signal
     real,dimension(:,:,:),pointer :: beta_tot   ! Total backscattered signal
     real,dimension(:,:,:),pointer :: tau_tot    ! Optical thickness integrated from top to level z
@@ -197,5 +200,11 @@
     real, dimension(:,:),pointer :: lidarcld    ! 3D "lidar" cloud fraction 
     ! Arrays with dimensions (Npoints,LIDAR_NCAT)
-    real, dimension(:,:),pointer :: cldlayer      ! low, mid, high-level lidar cloud cover
+    real, dimension(:,:),pointer :: cldlayer      ! low, mid, high-level, total lidar cloud cover
+   ! Arrays with dimensions (Npoints,Nlevels,Nphase)
+    real, dimension(:,:,:),pointer :: lidarcldphase    ! 3D "lidar" phase cloud fraction 
+     ! Arrays with dimensions (Npoints,LIDAR_NCAT,Nphase)
+    real, dimension(:,:,:),pointer :: cldlayerphase      ! low, mid, high-level lidar phase cloud cover
+    ! Arrays with dimensions (Npoints,Ntemps,Nphase)
+    real, dimension(:,:,:),pointer :: lidarcldtmp    ! 3D "lidar" phase cloud temperature
     ! Arrays with dimensions (Npoints,PARASOL_NREFL)
     real, dimension(:,:),pointer :: parasolrefl   ! mean parasol reflectance
@@ -230,4 +239,9 @@
                                                 ! (Reff==0 means use default size)   
                                                 ! (Npoints,Ncolumns,Nlevels,Nhydro) [m]
+    real,dimension(:,:,:,:),pointer :: Np       ! Total # concentration each hydrometeor 
+                                                ! (Optional, ignored if Reff > 0).
+                                                ! (Npoints,Ncolumns,Nlevels,Nhydro) [#/kg]
+                                                ! Np = Ntot / rho_a  = [#/m^3] / [kg/m^3) 
+                                                ! added by Roj with Quickbeam V3
   END TYPE COSP_SGHYDRO
   
@@ -246,4 +260,5 @@
     ! Time [days]
     double precision :: time
+    double precision :: time_bnds(2)
     
     ! Radar ancillary info
@@ -251,15 +266,12 @@
             k2 ! |K|^2, -1=use frequency dependent default
     integer :: surface_radar, & ! surface=1, spaceborne=0
-	       use_mie_tables, & ! use a precomputed loopup table? yes=1,no=0
-	       use_gas_abs, & ! include gaseous absorption? yes=1,no=0
-	       do_ray, & ! calculate/output Rayleigh refl=1, not=0
-	       melt_lay ! melting layer model off=0, on=1
+           use_mie_tables, & ! use a precomputed loopup table? yes=1,no=0
+           use_gas_abs, & ! include gaseous absorption? yes=1,no=0
+           do_ray, & ! calculate/output Rayleigh refl=1, not=0
+           melt_lay ! melting layer model off=0, on=1
  
     ! structures used by radar simulator that need to be set only ONCE per radar configuration (e.g. freq, pointing direction) ... added by roj Feb 2008
-    type(class_param) ::  hp	! structure used by radar simulator to store Ze and N scaling constants and other information
-    type(mie)::  mt		! structure used by radar simulator to store mie LUT information
-    integer :: nsizes 		! number of discrete drop sizes (um) used to represent the distribution
-    real*8, dimension(:), pointer :: D ! array of discrete drop sizes (um) used to represent the distribution
-    real*8, dimension(:), pointer :: mt_ttl, mt_tti ! array of temperatures used with Ze_scaling (also build into mie LUT)
+    type(class_param) ::  hp    ! structure used by radar simulator to store Ze and N scaling constants and other information
+    integer :: nsizes       ! number of discrete drop sizes (um) used to represent the distribution
     
     ! Lidar
@@ -269,7 +281,9 @@
     ! Radar
     logical ::  use_precipitation_fluxes  ! True if precipitation fluxes are input to the algorithm 
-    logical ::  use_reff  ! True if Reff is to be used by radar 
+    logical ::  use_reff          ! True if Reff is to be used by radar (memory not allocated
+    
     
     ! Geolocation (Npoints)
+    real,dimension(:),pointer :: toffset   ! Time offset of esch point from the value in time
     real,dimension(:),pointer :: longitude ! longitude [degrees East]
     real,dimension(:),pointer :: latitude  ! latitude [deg North]
@@ -302,5 +316,4 @@
     real,dimension(:),pointer :: sunlit ! (npoints) 1 for day points, 0 for nightime
     real,dimension(:),pointer :: skt  ! Skin temperature (K)
-    real,dimension(:),pointer :: sfc_height  ! Surface height [m]
     real,dimension(:),pointer :: u_wind  ! eastward wind [m s-1]
     real,dimension(:),pointer :: v_wind  ! northward wind [m s-1]
@@ -319,6 +332,11 @@
     real,dimension(:,:,:),pointer :: mr_hydro ! Mixing ratio of each hydrometeor (Npoints,Nlevels,Nhydro) [kg/kg]
     real,dimension(:,:),pointer   :: dist_prmts_hydro !Distributional parameters for hydrometeors (Nprmts_max_hydro,Nhydro)
-    ! Effective radius [m]. (Npoints,Nlevels,Nhydro)
+
+    ! Effective radius [m]. (Npoints,Nlevels,Nhydro) -- OPTIONAL, value of 0 mean use fixed default
     real,dimension(:,:,:),pointer :: Reff
+
+    ! Total Number Concentration [#/kg]. (Npoints,Nlevels,Nhydro) -- OPTIONAL, value of 0 mean use fixed default
+    real,dimension(:,:,:),pointer :: Np ! added by Roj with Quickbeam V3
+ 
     ! Aerosols concentration and distribution parameters
     real,dimension(:,:,:),pointer :: conc_aero ! Aerosol concentration for each species (Npoints,Nlevels,Naero)
@@ -373,15 +391,25 @@
 !------------- SUBROUTINE CONSTRUCT_COSP_RTTOV -------------------
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-  SUBROUTINE CONSTRUCT_COSP_RTTOV(Npoints,Nchan,x)
+  SUBROUTINE CONSTRUCT_COSP_RTTOV(cfg,Npoints,Nchan,x)
+    type(cosp_config),intent(in) :: cfg ! Configuration options
     integer,intent(in) :: Npoints  ! Number of sampled points
     integer,intent(in) :: Nchan ! Number of channels
     type(cosp_rttov),intent(out) :: x
-    
-    ! Dimensions
-    x%Npoints  = Npoints
-    x%Nchan    = Nchan
+    ! Local variables
+    integer :: i,j
+    
+    ! Allocate minumum storage if simulator not used
+    if (cfg%Lrttov_sim) then
+      i = Npoints
+      j = Nchan
+    else
+      i = 1
+      j = 1
+    endif
+    x%Npoints  = i
+    x%Nchan    = j
       
     ! --- Allocate arrays ---
-    allocate(x%tbs(Npoints, Nchan))
+    allocate(x%tbs(i, j))
     ! --- Initialise to zero ---
     x%tbs     = 0.0
@@ -608,5 +636,6 @@
     ! --- Allocate arrays ---
     allocate(x%beta_mol(i,k), x%beta_tot(i,j,k), &
-             x%tau_tot(i,j,k),x%refl(i,j,m))
+             x%tau_tot(i,j,k),x%refl(i,j,m), &
+             x%temp_tot(i,k),x%betaperp_tot(i,j,k))
     ! --- Initialise to zero ---
     x%beta_mol   = 0.0
@@ -614,4 +643,6 @@
     x%tau_tot    = 0.0
     x%refl       = 0.0 ! parasol
+    x%temp_tot   	= 0.0
+    x%betaperp_tot 	= 0.0	
   END SUBROUTINE CONSTRUCT_COSP_SGLIDAR
 
@@ -622,5 +653,7 @@
     type(cosp_sglidar),intent(inout) :: x
 
-    deallocate(x%beta_mol, x%beta_tot, x%tau_tot, x%refl)
+    deallocate(x%beta_mol, x%beta_tot, x%tau_tot, x%refl, &
+               x%temp_tot, x%betaperp_tot)
+
   END SUBROUTINE FREE_COSP_SGLIDAR
 
@@ -766,6 +799,8 @@
     
     ! --- Allocate arrays ---
-    allocate(x%srbval(SR_BINS),x%cfad_sr(i,SR_BINS,k), & 
+    allocate(x%srbval(SR_BINS),x%cfad_sr(i,SR_BINS,k), &
              x%lidarcld(i,k), x%cldlayer(i,LIDAR_NCAT), x%parasolrefl(i,m))
+    allocate(x%lidarcldphase(i,k,6),x%lidarcldtmp(i,LIDAR_NTEMP,5),&
+             x%cldlayerphase(i,LIDAR_NCAT,6))
     ! --- Initialise to zero ---
     x%srbval    = 0.0
@@ -774,5 +809,9 @@
     x%cldlayer  = 0.0
     x%parasolrefl  = 0.0
-  END SUBROUTINE CONSTRUCT_COSP_LIDARSTATS
+    x%lidarcldphase  = 0.0
+    x%cldlayerphase  = 0.0
+    x%lidarcldtmp  = 0.0
+
+   END SUBROUTINE CONSTRUCT_COSP_LIDARSTATS
 
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -783,6 +822,7 @@
 
     deallocate(x%srbval, x%cfad_sr, x%lidarcld, x%cldlayer, x%parasolrefl)
+    deallocate(x%cldlayerphase, x%lidarcldtmp, x%lidarcldphase)
   END SUBROUTINE FREE_COSP_LIDARSTATS
- 
+
 
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -849,8 +889,11 @@
     ! --- Allocate arrays ---
     allocate(y%mr_hydro(Npoints,Ncolumns,Nlevels,Nhydro), &
-             y%Reff(Npoints,Ncolumns,Nlevels,Nhydro))
+             y%Reff(Npoints,Ncolumns,Nlevels,Nhydro), &
+             y%Np(Npoints,Ncolumns,Nlevels,Nhydro)) ! added by roj with Quickbeam V3
+             
     ! --- Initialise to zero ---
     y%mr_hydro = 0.0
     y%Reff     = 0.0
+    y%Np       = 0.0                    ! added by roj with Quickbeam V3
 
   END SUBROUTINE CONSTRUCT_COSP_SGHYDRO
@@ -863,5 +906,5 @@
     
     ! --- Deallocate arrays ---
-    deallocate(y%mr_hydro, y%Reff)
+    deallocate(y%mr_hydro, y%Reff, y%Np)        ! added by Roj with Quickbeam V3
         
   END SUBROUTINE FREE_COSP_SGHYDRO
@@ -870,12 +913,13 @@
 !------------- SUBROUTINE CONSTRUCT_COSP_GRIDBOX ------------------
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-  SUBROUTINE CONSTRUCT_COSP_GRIDBOX(time,radar_freq,surface_radar,use_mie_tables,use_gas_abs,do_ray,melt_lay,k2, &
-                                   Npoints,Nlevels,Ncolumns,Nhydro,Nprmts_max_hydro,Naero,Nprmts_max_aero,Npoints_it, & 
+  SUBROUTINE CONSTRUCT_COSP_GRIDBOX(time,time_bnds,radar_freq,surface_radar,use_mie_tables,use_gas_abs,do_ray,melt_lay,k2, &
+                                   Npoints,Nlevels,Ncolumns,Nhydro,Nprmts_max_hydro,Naero,Nprmts_max_aero,Npoints_it, &
                                    lidar_ice_type,isccp_top_height,isccp_top_height_direction,isccp_overlap,isccp_emsfc_lw, &
                                    use_precipitation_fluxes,use_reff, &
                                    ! RTTOV inputs
                                    Plat,Sat,Inst,Nchan,ZenAng,Ichan,SurfEm,co2,ch4,n2o,co,&
-                                   y)
+                                   y,load_LUT)
     double precision,intent(in) :: time ! Time since start of run [days] 
+    double precision,intent(in) :: time_bnds(2) ! Time boundaries
     real,intent(in)    :: radar_freq, & ! Radar frequency [GHz]
                           k2            ! |K|^2, -1=use frequency dependent default
@@ -909,11 +953,17 @@
     real,intent(in)    :: co2,ch4,n2o,co
     type(cosp_gridbox),intent(out) :: y
-
-        
+    logical,intent(in),optional :: load_LUT
+
+
     ! local variables
-    integer i, cnt_ice, cnt_liq
-    character*200 :: mie_table_name ! Mie table name  
-    real*8  :: delt, deltp
- 
+    character*240 :: LUT_file_name
+    logical :: local_load_LUT
+
+    if (present(load_LUT)) then
+      local_load_LUT = load_LUT
+    else
+      local_load_LUT = RADAR_SIM_LOAD_scale_LUTs_flag
+    endif
+
     ! Dimensions and scalars
     y%radar_freq       = radar_freq
@@ -940,5 +990,6 @@
     y%use_reff = use_reff
     
-    y%time = time
+    y%time      = time
+    y%time_bnds = time_bnds
     
     ! RTTOV parameters
@@ -966,10 +1017,11 @@
              
     ! Surface information and geolocation (Npoints)
-    allocate(y%longitude(Npoints),y%latitude(Npoints),y%psfc(Npoints), y%land(Npoints), &
-             y%sunlit(Npoints),y%skt(Npoints),y%sfc_height(Npoints),y%u_wind(Npoints),y%v_wind(Npoints))
+    allocate(y%toffset(Npoints), y%longitude(Npoints),y%latitude(Npoints),y%psfc(Npoints), y%land(Npoints), &
+             y%sunlit(Npoints),y%skt(Npoints),y%u_wind(Npoints),y%v_wind(Npoints))
     ! Hydrometeors concentration and distribution parameters
     allocate(y%mr_hydro(Npoints,Nlevels,Nhydro), &
              y%dist_prmts_hydro(Nprmts_max_hydro,Nhydro), &
-             y%Reff(Npoints,Nlevels,Nhydro))
+             y%Reff(Npoints,Nlevels,Nhydro), &
+             y%Np(Npoints,Nlevels,Nhydro))      ! added by Roj with Quickbeam V3
     ! Aerosols concentration and distribution parameters
     allocate(y%conc_aero(Npoints,Nlevels,Naero), y%dist_type_aero(Naero), &
@@ -1004,4 +1056,5 @@
     y%snow_cv   = 0.0
     y%Reff      = 0.0
+    y%Np        = 0.0 ! added by Roj with Quickbeam V3
     y%mr_ozone  = 0.0
     y%u_wind    = 0.0
@@ -1010,5 +1063,5 @@
     
     ! (Npoints)
-!     call zero_real(y%psfc, y%land)
+    y%toffset = 0.0
     y%longitude = 0.0
     y%latitude = 0.0
@@ -1017,5 +1070,4 @@
     y%sunlit = 0.0
     y%skt = 0.0
-    y%sfc_height = 0.0
     ! (Npoints,Nlevels,Nhydro)
 !     y%fr_hydro = 0.0
@@ -1027,139 +1079,79 @@
     y%dist_prmts_aero  = 0.0 ! (Npoints,Nlevels,Nprmts_max_aero,Naero)
 
-    y%hp%p1 = 0.0
-    y%hp%p2 = 0.0
-    y%hp%p3 = 0.0
-    y%hp%dmin = 0.0
-    y%hp%dmax = 0.0
-    y%hp%apm = 0.0
-    y%hp%bpm = 0.0
-    y%hp%rho = 0.0
-    y%hp%dtype = 0
-    y%hp%col = 0
-    y%hp%cp = 0
-    y%hp%phase = 0
-    y%hp%scaled = .false.
-    y%hp%z_flag = .false.
-    y%hp%Ze_scaled = 0.0
-    y%hp%Zr_scaled = 0.0
-    y%hp%kr_scaled = 0.0
-    y%hp%fc = 0.0
-    y%hp%rho_eff = 0.0
-    y%hp%ifc = 0
-    y%hp%idd = 0
-    y%mt%freq = 0.0
-    y%mt%tt = 0.0
-    y%mt%f = 0.0
-    y%mt%D = 0.0
-    y%mt%qext = 0.0
-    y%mt%qbsca = 0.0
-    y%mt%phase = 0
-    
-    
-    ! --- Initialize the distributional parameters for hydrometeors
-    y%dist_prmts_hydro( 1,:) = HCLASS_TYPE(:)
-    y%dist_prmts_hydro( 2,:) = HCLASS_COL(:)
-    y%dist_prmts_hydro( 3,:) = HCLASS_PHASE(:)
-    y%dist_prmts_hydro( 4,:) = HCLASS_CP(:)
-    y%dist_prmts_hydro( 5,:) = HCLASS_DMIN(:)
-    y%dist_prmts_hydro( 6,:) = HCLASS_DMAX(:)
-    y%dist_prmts_hydro( 7,:) = HCLASS_APM(:)
-    y%dist_prmts_hydro( 8,:) = HCLASS_BPM(:)
-    y%dist_prmts_hydro( 9,:) = HCLASS_RHO(:)
-    y%dist_prmts_hydro(10,:) = HCLASS_P1(:)
-    y%dist_prmts_hydro(11,:) = HCLASS_P2(:)
-    y%dist_prmts_hydro(12,:) = HCLASS_P3(:)
-
-    ! the following code added by roj to initialize structures used by radar simulator, Feb 2008
-    call load_hydrometeor_classes(y%Nprmts_max_hydro,y%dist_prmts_hydro(:,:),y%hp,y%Nhydro)
-
-    ! load mie tables ?
-    if (y%use_mie_tables == 1) then
-
-        ! ----- Mie tables ----
-  	    mie_table_name='mie_table.dat'
-        call load_mie_table(mie_table_name,y%mt)
-	
-	    !   :: D specified by table ... not must match that used when mie LUT generated!
-    	y%nsizes = mt_nd
-    	allocate(y%D(y%nsizes))
-    	y%D = y%mt%D
-
-    else
-	   ! otherwise we still need to initialize temperature arrays for Ze scaling (which is only done when not using mie table)
-	   
-	   cnt_ice=19
-	   cnt_liq=20
-       if (.not.(allocated(mt_ttl).and.allocated(mt_tti))) then
-          allocate(mt_ttl(cnt_liq),mt_tti(cnt_ice))  ! note needed as this is global array ... 
-                                                     ! which should be changed in the future
-       endif
-		  
-	   do i=1,cnt_ice
-		  mt_tti(i)=(i-1)*5-90
-	   enddo
-    
-	   do i=1,cnt_liq
-		  mt_ttl(i)=(i-1)*5 - 60
-	   enddo 
-    
-	   allocate(y%mt_ttl(cnt_liq),y%mt_tti(cnt_ice))
-
-       y%mt_ttl = mt_ttl
-       y%mt_tti = mt_tti
-
-! !------ OLD code in v0.1 ---------------------------
-!        allocate(mt_ttl(2),mt_tti(2))
-!        allocate(y%mt_ttl(2),y%mt_tti(2))
-!        mt_ttl = 0.0
-!        mt_tti = 0.0
-!        y%mt_ttl = mt_ttl
-!        y%mt_tti = mt_tti
-! !---------------------------------------------------
-       
-       ! :: D created on a log-linear scale
-       y%nsizes = nd
-       delt = (log(dmax)-log(dmin))/(y%nsizes-1)
-       deltp = exp(delt)
-       allocate(y%D(y%nsizes))
-       y%D(1) = dmin
-       do i=2,y%nsizes
-          y%D(i) = y%D(i-1)*deltp
-       enddo   
-   
+
+    ! NOTE: This location use to contain initialization of some radar simulator variables
+    ! this initialization (including use of the variable "dist_prmts_hydro" - now obselete) 
+    ! has been unified in the quickbeam v3 subroutine "radar_simulator_init".   Roj, June 2010
+
+    ! --- Initialize the distributional parameters for hydrometeors in radar simulator
+
+    write(*,*) 'RADAR_SIM microphysics scheme is set to: ', &
+            trim(RADAR_SIM_MICROPHYSICS_SCHEME_NAME)
+
+
+    if(y%Nhydro.ne.N_HYDRO) then
+
+        write(*,*) 'Number of hydrometeor input to subroutine', &
+               ' CONSTRUCT_COSP_GRIDBOX does not match value', &
+               ' specified in cosp_constants.f90!'
+        write(*,*) 
     endif
 
+    ! NOTE: SAVE_scale_LUTs_flag is hard codded as .false. here 
+    ! so that radar simulator will NOT update LUT each time it 
+    ! is called, but rather will update when "Free_COSP_GRIDBOX" is called!
+    ! Roj, June 2010
+
+    LUT_file_name = trim(RADAR_SIM_LUT_DIRECTORY) // &
+                trim(RADAR_SIM_MICROPHYSICS_SCHEME_NAME)
+
+    call radar_simulator_init(radar_freq,k2, &
+                      use_gas_abs,do_ray,R_UNDEF, &
+                      y%Nhydro, &
+                      HCLASS_TYPE,HCLASS_PHASE, &
+                      HCLASS_DMIN,HCLASS_DMAX, &
+                      HCLASS_APM,HCLASS_BPM,HCLASS_RHO, &
+                      HCLASS_P1,HCLASS_P2,HCLASS_P3, &
+                      local_load_LUT,    &
+                      .false., &
+                      LUT_file_name, &
+                      y%hp)
 
 END SUBROUTINE CONSTRUCT_COSP_GRIDBOX
 
-  
+
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 !------------- SUBROUTINE FREE_COSP_GRIDBOX -----------------------
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-  SUBROUTINE FREE_COSP_GRIDBOX(y,dglobal)
+  SUBROUTINE FREE_COSP_GRIDBOX(y,dglobal,save_LUT)
+
+    use scale_LUTs_io
+
     type(cosp_gridbox),intent(inout) :: y
     logical,intent(in),optional :: dglobal
-
-    ! --- Free arrays ---
-    deallocate(y%D,y%mt_ttl,y%mt_tti)	! added by roj Feb 2008
-    if (.not.present(dglobal)) deallocate(mt_ttl,mt_tti)
-    
-!     deallocate(y%hp%p1,y%hp%p2,y%hp%p3,y%hp%dmin,y%hp%dmax,y%hp%apm,y%hp%bpm,y%hp%rho, &
-!               y%hp%dtype,y%hp%col,y%hp%cp,y%hp%phase,y%hp%scaled, &
-!               y%hp%z_flag,y%hp%Ze_scaled,y%hp%Zr_scaled,y%hp%kr_scaled, &
-!               y%hp%fc, y%hp%rho_eff, y%hp%ifc, y%hp%idd)
-!     deallocate(y%mt%freq, y%mt%tt, y%mt%f, y%mt%D, y%mt%qext, y%mt%qbsca, y%mt%phase)
-    
+    logical,intent(in),optional :: save_LUT
+
+    logical :: local_save_LUT
+
+    if (present(save_LUT)) then
+      local_save_LUT = save_LUT
+    else
+      local_save_LUT = RADAR_SIM_UPDATE_scale_LUTs_flag
+    endif
+
+    ! save any updates to radar simulator LUT
+    if (local_save_LUT) call save_scale_LUTs(y%hp)
+
     deallocate(y%zlev, y%zlev_half, y%dlev, y%p, y%ph, y%T, y%q, &
                y%sh, y%dtau_s, y%dtau_c, y%dem_s, y%dem_c, &
-               y%longitude,y%latitude,y%psfc, y%land, y%tca, y%cca, &
+               y%toffset, y%longitude,y%latitude,y%psfc, y%land, y%tca, y%cca, &
                y%mr_hydro, y%dist_prmts_hydro, &
                y%conc_aero, y%dist_type_aero, y%dist_prmts_aero, &
                y%rain_ls, y%rain_cv, y%snow_ls, y%snow_cv, y%grpl_ls, &
-               y%sunlit, y%skt, y%sfc_height, y%Reff,y%ichan,y%surfem, &
+               y%sunlit, y%skt, y%Reff,y%Np, &
+               y%ichan,y%surfem, &
                y%mr_ozone,y%u_wind,y%v_wind)
- 
+
   END SUBROUTINE FREE_COSP_GRIDBOX
-  
 
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@@ -1169,8 +1161,8 @@
     type(cosp_gridbox),intent(in) :: x
     type(cosp_gridbox),intent(inout) :: y
-    
+
     integer :: i,j,k,sz(3)
     double precision :: tny
-    
+
     tny = tiny(tny)
     y%hp%p1      = x%hp%p1
@@ -1189,12 +1181,12 @@
     y%hp%fc      = x%hp%fc
     y%hp%rho_eff = x%hp%rho_eff
-    y%hp%ifc     = x%hp%ifc
-    y%hp%idd     = x%hp%idd
-    sz = shape(x%hp%z_flag)
+    ! y%hp%ifc     = x%hp%ifc       obsolete, Roj, June 2010
+    ! y%hp%idd     = x%hp%idd
+    sz = shape(x%hp%Z_scale_flag)
     do k=1,sz(3)
       do j=1,sz(2)
         do i=1,sz(1)
-           if (x%hp%scaled(i,k))   y%hp%scaled(i,k)      = .true.
-           if (x%hp%z_flag(i,j,k)) y%hp%z_flag(i,j,k)    = .true.
+           if (x%hp%N_scale_flag(i,k))   y%hp%N_scale_flag(i,k)      = .true.
+           if (x%hp%Z_scale_flag(i,j,k)) y%hp%Z_scale_flag(i,j,k)    = .true.
            if (abs(x%hp%Ze_scaled(i,j,k)) > tny) y%hp%Ze_scaled(i,j,k) = x%hp%Ze_scaled(i,j,k)
            if (abs(x%hp%Zr_scaled(i,j,k)) > tny) y%hp%Zr_scaled(i,j,k) = x%hp%Zr_scaled(i,j,k)
@@ -1214,13 +1206,8 @@
     type(cosp_gridbox),intent(inout) :: y
     
-    integer :: i,j,k,sz(3)
-    
     ! --- Copy arrays without Npoints as dimension ---
     y%dist_prmts_hydro = x%dist_prmts_hydro
     y%dist_type_aero   = x%dist_type_aero
-    y%D                = x%D
-    y%mt_ttl           = x%mt_ttl
-    y%mt_tti           = x%mt_tti
-    
+  
     
 !     call cosp_gridbox_cphp(x,y)    
@@ -1233,5 +1220,4 @@
     y%sunlit(iy(1):iy(2))     = x%sunlit(ix(1):ix(2))
     y%skt(iy(1):iy(2))        = x%skt(ix(1):ix(2))
-    y%sfc_height(iy(1):iy(2)) = x%sfc_height(ix(1):ix(2))
     y%u_wind(iy(1):iy(2))     = x%u_wind(ix(1):ix(2))
     y%v_wind(iy(1):iy(2))     = x%v_wind(ix(1):ix(2))
@@ -1259,4 +1245,5 @@
     ! 3D
     y%Reff(iy(1):iy(2),:,:)      = x%Reff(ix(1):ix(2),:,:)
+    y%Np(iy(1):iy(2),:,:)      = x%Np(ix(1):ix(2),:,:)   ! added by Roj with Quickbeam V3
     y%conc_aero(iy(1):iy(2),:,:) = x%conc_aero(ix(1):ix(2),:,:)
     y%mr_hydro(iy(1):iy(2),:,:)  = x%mr_hydro(ix(1):ix(2),:,:)
@@ -1297,5 +1284,7 @@
     type(cosp_sglidar),intent(in) :: x
     type(cosp_sglidar),intent(inout) :: y
-    
+
+    y%temp_tot(iy(1):iy(2),:)       = x%temp_tot(ix(1):ix(2),:)
+    y%betaperp_tot(iy(1):iy(2),:,:) = x%betaperp_tot(ix(1):ix(2),:,:)
     y%beta_mol(iy(1):iy(2),:)       = x%beta_mol(ix(1):ix(2),:)
     y%beta_tot(iy(1):iy(2),:,:)     = x%beta_tot(ix(1):ix(2),:,:)
@@ -1311,5 +1300,5 @@
     type(cosp_isccp),intent(in) :: x
     type(cosp_isccp),intent(inout) :: y
-            
+
     y%fq_isccp(iy(1):iy(2),:,:)  = x%fq_isccp(ix(1):ix(2),:,:)
     y%totalcldarea(iy(1):iy(2))  = x%totalcldarea(ix(1):ix(2))
